
 import "Turbine.UI"; 
 import "Turbine.UI.Extensions"; 
 import "Turbine.UI.Lotro"; 

 import "Homeopatix.Caserne.Globals"
 import "Homeopatix.Caserne.MinimizedIcon"
 import "Homeopatix.Caserne.VindarPatch"
 import "Homeopatix.Caserne.Commands"
 import "Homeopatix.Caserne.LoadSettings"

Turbine.Shell.WriteLine("<rgb=#CC56DA>Caserne</rgb> <rgb=#DDDDDD>".. plugin:GetVersion() .." par Homeo</rgb>")

function SaveSettings()
		settings.positionX = tostring(settings.positionX);
   		settings.positionY = tostring(settings.positionY);
		settings.minimizeX = tostring(settings.minimizeX);
   		settings.minimizeY = tostring(settings.minimizeY);
		settings.isWindowVisible = settings.isWindowVisible;
		settings.shortcutData_1 = settings.shortcutData_1;
   		settings.shortcutData_2 = settings.shortcutData_2;
   		settings.shortcutData_3 = settings.shortcutData_3;
   		settings.shortcutData_4 = settings.shortcutData_4;
   
   -- save the settings
	PatchDataSave( Turbine.DataScope.Character, "Caserne_Settings", settings);
end

CreateLocalizationInfo();
LoadSettings();

------------------------------------------------------------------------------------------
-- create the main window
------------------------------------------------------------------------------------------
CaserneWindow=Turbine.UI.Lotro.GoldWindow(); 
CaserneWindow:SetSize(210,120); 
CaserneWindow:SetText(Strings.PluginName); 
CaserneWindow.Message=Turbine.UI.Label(); 
CaserneWindow.Message:SetParent(CaserneWindow); 
CaserneWindow.Message:SetSize(150,15); 
CaserneWindow.Message:SetPosition(CaserneWindow:GetWidth()/2 - 75, CaserneWindow:GetHeight()/2 + 40); 
CaserneWindow.Message:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter); 
CaserneWindow.Message:SetText(Strings.PluginText); 
CaserneWindow:SetWantsKeyEvents(true);

function CaserneWindow:Closing(sender, args)
	settings.isWindowVisible = false;
end

CaserneWindow:SetPosition(settings.positionX, settings.positionY);

------------------------------------------------------------------------------------------
-- handle minimizeIcon
------------------------------------------------------------------------------------------
MainMinimizedIcon = MinimizedIcon(Images.MinimizedIcon, 40, 40, CaserneWindow:SetVisible(false));
settings.isWindowVisible = false;
SaveSettings();
MainMinimizedIcon:SetPosition(settings.minimizeX, settings.minimizeY);
MainMinimizedIcon:SetZOrder(0);
MainMinimizedIcon.PositionChanged = function()
	settings.minimizeX = MainMinimizedIcon:GetLeft();
	settings.minimizeY = MainMinimizedIcon:GetTop();
	SaveSettings();
end

------------------------------------------------------------------------------------------
-- yel helper center window
------------------------------------------------------------------------------------------
centerWindow = Turbine.UI.Extensions.SimpleWindow();
centerWindow:SetSize( 36 , 36 );
centerWindow:SetParent( CaserneWindow );
centerWindow:SetPosition( 31 ,CaserneWindow:GetHeight()/2 - 12);
centerWindow:SetVisible( true );
centerWindow:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow2 = Turbine.UI.Extensions.SimpleWindow();
centerWindow2:SetSize( 36 , 36 );
centerWindow2:SetParent( CaserneWindow );
centerWindow2:SetPosition( 69 ,CaserneWindow:GetHeight()/2 - 12);
centerWindow2:SetVisible( true );
centerWindow2:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow3 = Turbine.UI.Extensions.SimpleWindow();
centerWindow3:SetSize( 36 , 36 );
centerWindow3:SetParent( CaserneWindow );
centerWindow3:SetPosition( 107,CaserneWindow:GetHeight()/2 - 12);
centerWindow3:SetVisible( true );
centerWindow3:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerWindow4 = Turbine.UI.Extensions.SimpleWindow();
centerWindow4:SetSize( 36 , 36 );
centerWindow4:SetParent( CaserneWindow );
centerWindow4:SetPosition( 145,CaserneWindow:GetHeight()/2 - 12);
centerWindow4:SetVisible( true );
centerWindow4:SetBackColor( Turbine.UI.Color( .6, .5, .7, .5) );

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow2);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow3);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerLabel = Turbine.UI.Label();
centerLabel:SetParent(centerWindow4);
centerLabel:SetPosition( 0, 0 );
centerLabel:SetSize( 36, 36  );
centerLabel:SetText( "" );
centerLabel:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
centerLabel:SetZOrder(-1);
centerLabel:SetMouseVisible(false);

centerQS1 = Turbine.UI.Lotro.Quickslot();
centerQS1:SetParent( centerWindow );
centerQS1:SetPosition( 0, 0 );
centerQS1:SetSize( 35, 35 );
centerQS1:SetUseOnRightClick(false);

centerQS2 = Turbine.UI.Lotro.Quickslot();
centerQS2:SetParent( centerWindow2 );
centerQS2:SetPosition( 0, 0 );
centerQS2:SetSize( 35, 35 );
centerQS2:SetUseOnRightClick(false);

centerQS3 = Turbine.UI.Lotro.Quickslot();
centerQS3:SetParent( centerWindow3 );
centerQS3:SetPosition( 0, 0 );
centerQS3:SetSize( 35, 35 );
centerQS3:SetUseOnRightClick(false);

centerQS4 = Turbine.UI.Lotro.Quickslot();
centerQS4:SetParent( centerWindow4 );
centerQS4:SetPosition( 0, 0 );
centerQS4:SetSize( 35, 35 );
centerQS4:SetUseOnRightClick(false);

------------------------------------------------------------------------------------------
-- setting the shortcuts
------------------------------------------------------------------------------------------
if(settings.shortcutData_1 ~= "") then
	centerQS1:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_1, settings.shortcutData_1 ) );
end
if(settings.shortcutData_2 ~= "") then
	centerQS2:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_2, settings.shortcutData_2 ) );
end
if(settings.shortcutData_3 ~= "") then
	centerQS3:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_3, settings.shortcutData_3 ) );
end
if(settings.shortcutData_4 ~= "") then
	centerQS4:SetShortcut( Turbine.UI.Lotro.Shortcut( settings.shortcutType_4, settings.shortcutData_4 ) );
end

settings.shortcutData_1 = "0x7000FC78"; -- morceaux de fruit pourrit non theatre
settings.shortcutData_2 = "0x70002FAF"; -- ptale de fleurs de rivegel
settings.shortcutData_3 = "0x70002F1A"; -- morceaux de fruit pourri pour le theatre
settings.shortcutData_4 = "0x70002F7A"; -- boule de neige parfaite pour l'instance
centerQS1:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_1 ) );
centerQS2:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_2 ) );
centerQS3:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_3 ) );
centerQS4:SetShortcut( Turbine.UI.Lotro.Shortcut( 6, settings.shortcutData_4 ) );

------------------------------------------------------------------------------------------
-- setting the shortcuts for drag and drop
------------------------------------------------------------------------------------------
centerQS1.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS1:GetShortcut();
	tmp = tmp:GetData();
	
	local tmp2 = Turbine.UI.Lotro.Quickslot();
	tmp2 = centerQS1:GetShortcut();
	tmp2 = tmp2:GetType();

	
	--Turbine.Shell.WriteLine("Data : " .. tmp); -- display the ID of the schortcut
	--Turbine.Shell.WriteLine("Type : " .. tmp2); -- display the Type of the schortcut

	settings.shortcutData_1 = tmp;

	SaveSettings();
end
centerQS2.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS2:GetShortcut();
	tmp = tmp:GetData();
	
	settings.shortcutData_2 = tmp;

	SaveSettings();
end
centerQS3.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS3:GetShortcut();
	tmp = tmp:GetData();
	
	settings.shortcutData_3 = tmp;

	SaveSettings();
end
centerQS4.DragDrop = function(sender, args)
	local tmp = Turbine.UI.Lotro.Quickslot();
		
	tmp = centerQS4:GetShortcut();
	tmp = tmp:GetData();
	
	settings.shortcutData_4 = tmp;

	SaveSettings();
end

------------------------------------------------------------------------------------------
-- mouse handler
------------------------------------------------------------------------------------------
centerQS1.MouseEnter = function(sender, args)
	CaserneWindow.Message:SetText(""); 
	CaserneWindow.Message:SetText(Strings.PluginHerault1); 
end

centerQS2.MouseEnter = function(sender, args)
	CaserneWindow.Message:SetText("");
	CaserneWindow.Message:SetText(Strings.PluginHerault2); 
end

centerQS3.MouseEnter = function(sender, args)
	CaserneWindow.Message:SetText(""); 
	CaserneWindow.Message:SetText(Strings.PluginHerault3); 
end

centerQS4.MouseEnter = function(sender, args)
	CaserneWindow.Message:SetText("");
	CaserneWindow.Message:SetText(Strings.PluginHerault4); 
end

centerQS1.MouseLeave = function(sender, args)
	CaserneWindow.Message:SetText(Strings.PluginText);
end

centerQS2.MouseLeave = function(sender, args)
	CaserneWindow.Message:SetText(Strings.PluginText);
end

centerQS3.MouseLeave = function(sender, args)
	CaserneWindow.Message:SetText(Strings.PluginText);
end

centerQS4.MouseLeave = function(sender, args)
	CaserneWindow.Message:SetText(Strings.PluginText);
end

centerQS1.MouseClick = function(sender, args)
	CaserneWindow:SetVisible(false);
	settings.isWindowVisible = false;
	SaveSettings();
end

centerQS2.MouseClick = function(sender, args)
	CaserneWindow:SetVisible(false);
	settings.isWindowVisible = false;
	SaveSettings();
end

centerQS3.MouseClick = function(sender, args)
	CaserneWindow:SetVisible(false);
	settings.isWindowVisible = false;
	SaveSettings();
end

centerQS4.MouseClick = function(sender, args)
	CaserneWindow:SetVisible(false);
	settings.isWindowVisible = false;
	SaveSettings();
end


------------------------------------------------------------------------------------------
-- delete the shortcut with mouse wheel
------------------------------------------------------------------------------------------

centerQS1.MouseWheel = function(sender, args)
	settings.shortcutData_1 = tostring(""); 
	centerQS1:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS2.MouseWheel = function(sender, args)
	settings.shortcutData_2 = tostring(""); 
	centerQS2:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS3.MouseWheel = function(sender, args)
	settings.shortcutData_3 = tostring(""); 
	centerQS3:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end
centerQS4.MouseWheel = function(sender, args)
	settings.shortcutData_4 = tostring(""); 
	centerQS4:SetShortcut(Turbine.UI.Lotro.Shortcut());
	SaveSettings();
end

------------------------------------------------------------------------------------------
-- event handling
------------------------------------------------------------------------------------------
CaserneWindow.KeyDown=function(sender, args)
	if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
		CaserneWindow:SetVisible(false);
		settings.isWindowVisible = false;
		SaveSettings();
	end
	
	-- https://www.lotro.com/forums/showthread.php?493466-How-to-hide-a-window-on-F12&p=6581962#post6581962
	if ( args.Action == 268435635 ) then
		hudVisible=not hudVisible;
		if hudVisible then
			CaserneWindow:SetVisible(false);
			MainMinimizedIcon:SetVisible(false);
		else
			CaserneWindow:SetVisible(settings.isWindowVisible);
			MainMinimizedIcon:SetVisible(true);
		end
	end
end
------------------------------------------------------------------------------------------
-- if the position changes, save the new window location
------------------------------------------------------------------------------------------
	CaserneWindow.PositionChanged = function( sender, args )
    	local x,y = CaserneWindow:GetPosition();
    	settings.positionX = x;
    	settings.positionY = y;
		SaveSettings();
	end

				
	



